import org.lwjgl.BufferUtils;
import org.lwjgl.opengl.ARBVertexBufferObject;
import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.GLContext;
import org.newdawn.slick.opengl.Texture;
import org.newdawn.slick.opengl.TextureLoader;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.nio.IntBuffer;

public class Block {
    private float pos[];
    private float normalVectors[][] = {{0f, 0f, 0f}, {0f,0f,0f}, {0f,0f,0f}, {0f, 0f, 0f}, {0f,0f,0f}, {0f,0f,0f}};
    public boolean visible;
    private int type;
    public static int dirt = 1, stone = 2, sand = 3;
    private float verticles[][][]   = {
            {{-50f, -50f, 50f}, {50f, -50f, 50f}, {50f, 50f, 50f}, {-50f, 50f, 50f}},
            {{-50f, -50f, -50f}, {50f, -50f, -50f}, {50f, 50f, -50f}, {-50f, 50f, -50f}},
            {{50f, -50f, -50f}, {50f, 50f, -50f}, {50f, 50f, 50f}, {50f, -50f, 50f}},
            {{-50f, -50f, -50f}, {-50f, 50f, -50f}, {-50f, 50f, 50f}, {-50f, -50f, 50f}},
            {{-50f, 50f, -50f}, {-50f, 50f, 50f}, {50f, 50f, 50f}, {50f, 50f, -50f}},
            {{-50f, -50f, -50f}, {-50f, -50f, 50f}, {50f, -50f, 50f}, {50f, -50f, -50f}},
        };
    Texture bottomTexture, Texture, sideTexture;
    private int compiledBlock;

    public void setPos(float x, float y, float z) {
        pos[0] = x;
        pos[1] = y;
        pos[2] = z;

    }

    private static float[] calculateSurfaceNormalFromPolygon(float[] v1, float[] v2, float[] v3) {
        float N[] = {0f, 0f, 0f};

        //for v1
        N[0] += (v1[1] - v2[1]) * (v1[2] + v2[2]);
        N[1] += (v1[2] - v2[2]) * (v1[0] + v2[0]);
        N[2] += (v1[0] - v2[0]) * (v1[1] + v2[1]);

        //for v2
        N[0] += (v2[1] - v3[1]) * (v2[2] + v3[2]);
        N[1] += (v2[2] - v3[2]) * (v2[0] + v3[0]);
        N[2] += (v2[0] - v3[0]) * (v2[1] + v3[1]);

        //for v3
        N[0] += (v3[1] - v1[1]) * (v3[2] + v1[2]);
        N[1] += (v3[2] - v1[2]) * (v3[0] + v1[0]);
        N[2] += (v3[0] - v1[0]) * (v3[1] + v1[1]);
        float elojel = -Math.signum(v1[0]*v2[0]*v3[0]*v1[1]*v2[1]*v3[1]*v1[2]*v2[2]*v3[2]);
        N[0] *= elojel;
        N[1] *= elojel;
        N[2] *= elojel;
        return N;

    }
    private static float[] normalizeNormalVector(float[] N) {
        float[] newN = {0f, 0f, 0f};
        float length = (N[0] * N[0]) + (N[1] * N[1]) + (N[2] * N[2]);
        length = (float) Math.sqrt(length);
        newN[0] = N[0] / length;
        newN[1] = N[1] / length;
        newN[2] = N[2] / length;
        return newN;
    }

    public void render(){
        if(visible){
            GL11.glPushMatrix();
            GL11.glTranslatef(pos[0], pos[1], pos[2]);
            GL11.glCallList(compiledBlock);
            GL11.glPopMatrix();
        }

    }
    
    public void setType(int type){
        this.type = type;
        GL11.glDeleteLists(compiledBlock, 1);
        switch (type){
            case 1:
                    setToDirt();
                    break;
            case 2:
                   setToStone();
                   break;
        }
        
    }

    private void setToStone(){
        compiledBlock = GL11.glGenLists(1);
        GL11.glNewList(compiledBlock, GL11.GL_COMPILE_AND_EXECUTE);
        //sideTexture.bind();
        GL11.glBegin(GL11.GL_QUADS);
        GL11.glTexCoord2f(0.375f, 0.0f);
        GL11.glNormal3f(0f, 0f, 1f);
        GL11.glVertex3f(-200f, -200f, 200f);
        GL11.glTexCoord2f(0.500f, 0.0f);
        GL11.glVertex3f(200f, -200f, 200f);
        GL11.glTexCoord2f(0.500f, 0.125f);
        GL11.glVertex3f(200f, 200f, 200f);
        GL11.glTexCoord2f(0.375f, 0.125f);
        GL11.glVertex3f(-200f, 200f, 200f);
        GL11.glEnd();

        GL11.glBegin(GL11.GL_QUADS);
        GL11.glNormal3f(0f, 0f, -1f);
        GL11.glTexCoord2f(0.375f, 0.0f);
        GL11.glVertex3f(-200f, -200f, -200f);
        GL11.glTexCoord2f(0.500f, 0.0f);
        GL11.glVertex3f(200f, -200f, -200f);
        GL11.glTexCoord2f(0.500f, 0.125f);
        GL11.glVertex3f(200f, 200f, -200f);
        GL11.glTexCoord2f(0.375f, 0.125f);
        GL11.glVertex3f(-200f, 200f, -200f);
        GL11.glEnd();

        GL11.glBegin(GL11.GL_QUADS);
        GL11.glNormal3f(1f, 0f, 0f);
        GL11.glTexCoord2f(0.500f, 0.0f);
        GL11.glVertex3f(200f, -200f, -200f);
        GL11.glTexCoord2f(0.500f, 0.125f);
        GL11.glVertex3f(200f, 200f, -200f);
        GL11.glTexCoord2f(0.375f, 0.125f);
        GL11.glVertex3f(200f, 200f, 200f);
        GL11.glTexCoord2f(0.375f, 0.0f);
        GL11.glVertex3f(200f, -200f, 200f);
        GL11.glEnd();


        GL11.glBegin(GL11.GL_QUADS);
        GL11.glNormal3f(-1f, 0f, 0f);
        GL11.glTexCoord2f(0.500f, 0.0f);
        GL11.glVertex3f(-200f, -200f, -200f);
        GL11.glTexCoord2f(0.500f, 0.125f);
        GL11.glVertex3f(-200f, 200f, -200f);
        GL11.glTexCoord2f(0.375f, 0.125f);
        GL11.glVertex3f(-200f, 200f, 200f);
        GL11.glTexCoord2f(0.375f, 0.0f);
        GL11.glVertex3f(-200f, -200f, 200f);
        GL11.glEnd();

        //bottomTexture
        GL11.glBegin(GL11.GL_QUADS);
        GL11.glNormal3f(0f, 1f, 0f);
        GL11.glTexCoord2f(0.500f, 0.0f);
        GL11.glVertex3f(-200f, 200f, -200f);
        GL11.glTexCoord2f(0.500f, 0.125f);
        GL11.glVertex3f(-200f, 200f, 200f);
        GL11.glTexCoord2f(0.375f, 0.125f);
        GL11.glVertex3f(200f, 200f, 200f);
        GL11.glTexCoord2f(0.375f, 0.0f);
        GL11.glVertex3f(200f, 200f, -200f);
        GL11.glEnd();


        //Texture.bind();
        GL11.glBegin(GL11.GL_QUADS);
        GL11.glNormal3f(0f, -1f, 0f);
        GL11.glTexCoord2f(0.375f, 0.0f);
        GL11.glVertex3f(-200f, -200f, -200f);
        GL11.glTexCoord2f(0.375f, 0.125f);
        GL11.glVertex3f(-200f, -200f, 200f);
        GL11.glTexCoord2f(0.500f, 0.125f);
        GL11.glVertex3f(200f, -200f, 200f);
        GL11.glTexCoord2f(0.500f, 0.0f);
        GL11.glVertex3f(200f, -200f, -200f);
        GL11.glEnd();
        GL11.glEndList();

    }

    private void setToDirt(){
        compiledBlock = GL11.glGenLists(1);
        GL11.glNewList(compiledBlock, GL11.GL_COMPILE_AND_EXECUTE);
        //sideTexture.bind();
        GL11.glBegin(GL11.GL_QUADS);
        GL11.glTexCoord2f(0.125f, 0.0f);
        GL11.glNormal3f(0f, 0f, 1f);
        GL11.glVertex3f(-200f, -200f, 200f);
        GL11.glTexCoord2f(0.250f, 0.0f);
        GL11.glVertex3f(200f, -200f, 200f);
        GL11.glTexCoord2f(0.250f, 0.125f);
        GL11.glVertex3f(200f, 200f, 200f);
        GL11.glTexCoord2f(0.125f, 0.125f);
        GL11.glVertex3f(-200f, 200f, 200f);
        GL11.glEnd();

        GL11.glBegin(GL11.GL_QUADS);
        GL11.glNormal3f(0f, 0f, -1f);
        GL11.glTexCoord2f(0.125f, 0.0f);
        GL11.glVertex3f(-200f, -200f, -200f);
        GL11.glTexCoord2f(0.250f, 0.0f);
        GL11.glVertex3f(200f, -200f, -200f);
        GL11.glTexCoord2f(0.250f, 0.125f);
        GL11.glVertex3f(200f, 200f, -200f);
        GL11.glTexCoord2f(0.125f, 0.125f);
        GL11.glVertex3f(-200f, 200f, -200f);
        GL11.glEnd();

        GL11.glBegin(GL11.GL_QUADS);
        GL11.glNormal3f(1f, 0f, 0f);
        GL11.glTexCoord2f(0.25f, 0.0f);
        GL11.glVertex3f(200f, -200f, -200f);
        GL11.glTexCoord2f(0.250f, 0.125f);
        GL11.glVertex3f(200f, 200f, -200f);
        GL11.glTexCoord2f(0.125f, 0.125f);
        GL11.glVertex3f(200f, 200f, 200f);
        GL11.glTexCoord2f(0.125f, 0.0f);
        GL11.glVertex3f(200f, -200f, 200f);
        GL11.glEnd();


        GL11.glBegin(GL11.GL_QUADS);
        GL11.glNormal3f(-1f, 0f, 0f);
        GL11.glTexCoord2f(0.25f, 0.0f);
        GL11.glVertex3f(-200f, -200f, -200f);
        GL11.glTexCoord2f(0.25f, 0.125f);
        GL11.glVertex3f(-200f, 200f, -200f);
        GL11.glTexCoord2f(0.125f, 0.125f);
        GL11.glVertex3f(-200f, 200f, 200f);
        GL11.glTexCoord2f(0.125f, 0.0f);
        GL11.glVertex3f(-200f, -200f, 200f);
        GL11.glEnd();

        //bottomTexture.bind();
        GL11.glBegin(GL11.GL_QUADS);
        GL11.glNormal3f(0f, 1f, 0f);
        GL11.glTexCoord2f(0.250f, 0.0f);
        GL11.glVertex3f(-200f, 200f, -200f);
        GL11.glTexCoord2f(0.250f, 0.125f);
        GL11.glVertex3f(-200f, 200f, 200f);
        GL11.glTexCoord2f(0.375f, 0.125f);
        GL11.glVertex3f(200f, 200f, 200f);
        GL11.glTexCoord2f(0.375f, 0.0f);
        GL11.glVertex3f(200f, 200f, -200f);
        GL11.glEnd();


        //Texture.bind();
        GL11.glBegin(GL11.GL_QUADS);
        GL11.glNormal3f(0f, -1f, 0f);
        GL11.glTexCoord2f(0.0f, 0.0f);
        GL11.glVertex3f(-200f, -200f, -200f);
        GL11.glTexCoord2f(0.0f, 0.125f);
        GL11.glVertex3f(-200f, -200f, 200f);
        GL11.glTexCoord2f(0.125f, 0.125f);
        GL11.glVertex3f(200f, -200f, 200f);
        GL11.glTexCoord2f(0.125f, 0.0f);
        GL11.glVertex3f(200f, -200f, -200f);
        GL11.glEnd();
        GL11.glEndList();

    }


    public Block(boolean visible){
        try{
        Texture = TextureLoader.getTexture("png", new FileInputStream("images/textures.png"));
        GL11.glTexParameteri(GL11.GL_TEXTURE_2D, GL11.GL_TEXTURE_MIN_FILTER, GL11.GL_NEAREST);
        GL11.glTexParameteri(GL11.GL_TEXTURE_2D, GL11.GL_TEXTURE_MAG_FILTER, GL11.GL_NEAREST);
        }catch(FileNotFoundException e){
            e.printStackTrace(); 
        }
        catch(IOException e){
            e.printStackTrace();
        }

        for(int i = 0; i < 6; i++){
            normalVectors[i] = calculateSurfaceNormalFromPolygon(verticles[i][0], verticles[i][1], verticles[i][2]);
            normalVectors[i] = normalizeNormalVector(normalVectors[i]);
        }
        for(int i =0; i<6; i++){
            System.out.println("#"+i+": X="+normalVectors[i][0]+" Y="+normalVectors[i][1]+" Z="+normalVectors[i][2]);

        }
        compiledBlock = GL11.glGenLists(1);
        GL11.glNewList(compiledBlock, GL11.GL_COMPILE_AND_EXECUTE);
        //sideTexture.bind();
        GL11.glBegin(GL11.GL_QUADS);
        GL11.glTexCoord2f(0.125f, 0.0f);
        GL11.glNormal3f(0f, 0f, 1f);
        GL11.glVertex3f(-200f, -200f, 200f);
        GL11.glTexCoord2f(0.250f, 0.0f);
        GL11.glVertex3f(200f, -200f, 200f);
        GL11.glTexCoord2f(0.250f, 0.125f);
        GL11.glVertex3f(200f, 200f, 200f);
        GL11.glTexCoord2f(0.125f, 0.125f);
        GL11.glVertex3f(-200f, 200f, 200f);
        GL11.glEnd();

        GL11.glBegin(GL11.GL_QUADS);
        GL11.glNormal3f(0f, 0f, -1f);
        GL11.glTexCoord2f(0.125f, 0.0f);
        GL11.glVertex3f(-200f, -200f, -200f);
        GL11.glTexCoord2f(0.250f, 0.0f);
        GL11.glVertex3f(200f, -200f, -200f);
        GL11.glTexCoord2f(0.250f, 0.125f);
        GL11.glVertex3f(200f, 200f, -200f);
        GL11.glTexCoord2f(0.125f, 0.125f);
        GL11.glVertex3f(-200f, 200f, -200f);
        GL11.glEnd();

        GL11.glBegin(GL11.GL_QUADS);
        GL11.glNormal3f(1f, 0f, 0f);
        GL11.glTexCoord2f(0.25f, 0.0f);
        GL11.glVertex3f(200f, -200f, -200f);
        GL11.glTexCoord2f(0.250f, 0.125f);
        GL11.glVertex3f(200f, 200f, -200f);
        GL11.glTexCoord2f(0.125f, 0.125f);
        GL11.glVertex3f(200f, 200f, 200f);
        GL11.glTexCoord2f(0.125f, 0.0f);
        GL11.glVertex3f(200f, -200f, 200f);
        GL11.glEnd();


        GL11.glBegin(GL11.GL_QUADS);
        GL11.glNormal3f(-1f, 0f, 0f);
        GL11.glTexCoord2f(0.25f, 0.0f);
        GL11.glVertex3f(-200f, -200f, -200f);
        GL11.glTexCoord2f(0.25f, 0.125f);
        GL11.glVertex3f(-200f, 200f, -200f);
        GL11.glTexCoord2f(0.125f, 0.125f);
        GL11.glVertex3f(-200f, 200f, 200f);
        GL11.glTexCoord2f(0.125f, 0.0f);
        GL11.glVertex3f(-200f, -200f, 200f);
        GL11.glEnd();

        //bottomTexture.bind();
        GL11.glBegin(GL11.GL_QUADS);
        GL11.glNormal3f(0f, 1f, 0f);
        GL11.glTexCoord2f(0.250f, 0.0f);
        GL11.glVertex3f(-200f, 200f, -200f);
        GL11.glTexCoord2f(0.250f, 0.125f);
        GL11.glVertex3f(-200f, 200f, 200f);
        GL11.glTexCoord2f(0.375f, 0.125f);
        GL11.glVertex3f(200f, 200f, 200f);
        GL11.glTexCoord2f(0.375f, 0.0f);
        GL11.glVertex3f(200f, 200f, -200f);
        GL11.glEnd();


        //Texture.bind();
        GL11.glBegin(GL11.GL_QUADS);
        GL11.glNormal3f(0f, -1f, 0f);
        GL11.glTexCoord2f(0.0f, 0.0f);
        GL11.glVertex3f(-200f, -200f, -200f);
        GL11.glTexCoord2f(0.0f, 0.125f);
        GL11.glVertex3f(-200f, -200f, 200f);
        GL11.glTexCoord2f(0.125f, 0.125f);
        GL11.glVertex3f(200f, -200f, 200f);
        GL11.glTexCoord2f(0.125f, 0.0f);
        GL11.glVertex3f(200f, -200f, -200f);
        GL11.glEnd();
        GL11.glEndList();
        
        
        pos = new float[3];
        this.visible = visible;
        type = 1;

    }

    private static int createVBOID() {
        if (GLContext.getCapabilities().GL_ARB_vertex_buffer_object) {
            IntBuffer buffer = BufferUtils.createIntBuffer(1);
            ARBVertexBufferObject.glGenBuffersARB(buffer);
            return buffer.get(0);
        }
        return 0;
    }




    
}
